% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ,=³ .### #######. .#####.  .#####.   #####.##. #. ######## ## Rheinisch-
%  [==].###   ##   ## ##   ##  ##   ##   ##  ##'##.##.## ## ## ## Westfälische
%   //l###    ##   ## ####. ' ##       @ #####' '####### ## ##### Technische
%  [==]##     ##|=##   ##=>#  ##         ##  ##  '##'### ## ## ## Hochschule
%  [==]###    ##   ## . '#### ##  '###   ##   ##  '# '## ## ## ## Aachen
%  [==]'###   ##   ## ##   ##  ##   ##
%  o^^o '### #######' '#####'O '#####'       http://kbsg.rwth-aachen.de/
%  Knowledge  Based   Systems   Group
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\documentclass{beamer}

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Mode
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\mode<presentation>
{
  \usetheme[hideallsubsections]{Aachen}
  % \usetheme{Luebeck}
  % oder ...
  %%
  \setbeamercovered{transparent}
  % oder auch nicht
}



%%%%%%%%%%%%%
\newcommand{\topalign}[1]{%
  \begin{columns}%
    \begin{column}[T]{0pt}%
      \vspace*{\textheight}%
    \end{column}%
    \begin{column}[T]{\textwidth}%
      #1%
    \end{column}%
  \end{columns}%
}


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Packages
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% As to have german umlauts etc use utf (you might need 
%% to tell your editor to save file with this encoding!)
\usepackage[utf8]{inputenc}
\usefonttheme[onlymath]{serif}
\usepackage{times}
\usepackage[T1]{fontenc}
\usepackage{listings}
\usepackage{textcomp}
\usepackage{subcaption}
%\usepackage{psfrag}
%\usepackage{rotating}
%\usepackage{xmpmulti}
%\usepackage{pgfarrows}
%\usepackage{tabularx}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{algorithm}
%\resetcounteronoverlays{algorithm}
\usepackage{algpseudocode}

\usepackage{amssymb}
\usepackage[euler]{textgreek}

\usepackage{tikz}
\usetikzlibrary{shapes}
\usepackage{booktabs}
\usepackage{wrapfig}

%% program listings and such things
%\usepackage{algorithmic}
%\usepackage{program}

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Macros/Defs
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\colorlet{lightblue}{blue!50!white}

\setbeamercovered{invisible}

\def\blue#1{\color{blue}#1\color{black}}
\def\lightblue#1{\color{lightblue}#1\color{black}}
%\def\lightblue#1{\color{blue}\begin{colormixin}{10!white}#1\end{colormixin}\color{black}}
\def\red#1{\color{red}#1\color{black}}
\def\todo#1{{\color{red}{\bfseries \fbox{ToDo}}\enspace #1}}

\usepackage{caption}
\captionsetup[subfigure]{labelformat=empty}
\captionsetup[figure]{labelformat=empty}

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Title Information
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\title[]{Code Generation for 3D-printing a Heart Valve}

\author[]{Florian Hövelmann}

\date[] % (optional, sollte der Tag des Vortrags sein)
{}

\subject{Subject}

\pgfdeclareimage[height=0.5cm]{university-logo}{pics/logo_blau_rechts}
\logo{\pgfuseimage{university-logo}}

%%% Soll vor jeder Section eine ToC Folie erscheinen?
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% make the title area

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Begin Document
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{document}

\begin{frame}
  \titlepage
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Introduction}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Introduction}
  %%
  \begin{itemize}
  \item Patient specific 3D models have wide application range
  \vspace{0.1cm}\pause
  \begin{itemize}
  \item Functional flow models
  \vspace{0.1cm}\pause
  \item Teaching tool
  \vspace{0.1cm}\pause
  \item Plan and simulate operation procedure
  \vspace{0.1cm}\pause
  \item Testing of current devices
  \vspace{0.1cm}\pause
  \item Patient specific cardiovascular prosthesis
  \end{itemize}
  \vspace{0.1cm}\pause
  \item Still lots of issues to be solved
  \vspace{0.1cm}\pause
  \item Further research and development needed
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Overall Procedure}
  %%
  \vspace{-0.4cm}
  \begin{figure}[h]
    \centering
	  \includegraphics[scale=0.12]{images/completeProcedure}
  	\caption{All steps for patient specific prints~\cite{cardiac1}}
  	\label{fig:dib}
  \end{figure}
  \vspace{-0.7cm}
  \begin{itemize}
  \item Stereolithography most common printing method
  \vspace{0.1cm}\pause
  \item Recently fused deposition modeling \& polyurethane
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Study from ETH}
  %%
  \vspace{-0.5cm}
\begin{overprint}
\onslide<1>\begin{figure}[H]
		\centering
		\includegraphics[scale=0.15]{images/eth}
		\caption{Individual heart valve printing based on direct ink writing~\cite{eth}}
\end{figure}
\onslide<2>\begin{figure}[H]
		\centering
		\includegraphics[scale=0.15]{images/eth2}
		\caption{Individual heart valve printing based on direct ink writing~\cite{eth}}
\end{figure}
\end{overprint}
\begin{itemize}
\item Achieved larger orifice area while reducing regurgitation
\end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Preliminaries}
  %%
  \begin{itemize}
  \item Robot
  \vspace{0.1cm}
  \begin{itemize}
  \item Define coordinate system, e.g. printer tip position
  \vspace{0.1cm}\pause
  \item Cartesian points $x,y,z$ and $rx,ry,rz$ for rotation
  \vspace{0.1cm}\pause
  \item Val3 Files for data and code
  \vspace{0.1cm}\pause
  \end{itemize}
  \item STL
  \vspace{0.1cm}
  \begin{itemize}
  \item Representation of 3D object via triangles
  \vspace{0.1cm}\pause
  \item Each having a normal for face orientation
  \end{itemize}
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Requirements}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Requirements}
  %%
   \vspace{-0.5cm}
   \begin{figure}[h]
    \centering
	  \includegraphics[scale=0.6]{images/pipelineStart2}
  	\caption{Input and output of the software}
  	\label{fig:dib}
  \end{figure}
  \begin{itemize}
  \vspace{-0.5cm}
  \item Capable of handling patient specific models $\Rightarrow$ STL
  \vspace{0.1cm}\pause
  \item Offer usage of different inks like polyurethane $\Rightarrow$ direct ink writing
  \vspace{0.1cm}\pause
  \item Obtain equidistant points and their normals $\Rightarrow$ Python
  \vspace{0.1cm}\pause
  \item Custom printing procedure $\Rightarrow$ configuration files 
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{From Model to Code}
\iffalse
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Overview}
  %%
\begin{overprint}
\onslide<1>
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.7]{images/animated/pipeline0.png}
\end{figure}
\vspace{-0.6cm}\begin{itemize}
\item How to generate equidistant points on complex curved surface?
\end{itemize}
\onslide<2>
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.7]{images/animated/pipeline1.png}
\end{figure}
\vspace{-0.6cm}\begin{itemize}
\item Simplifies the problem
\item Allows for individual printing of components
\end{itemize}
\onslide<3>
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.7]{images/animated/pipeline2.png}
\end{figure}
\vspace{-0.6cm}\begin{itemize}
\item Map curved surface to flat one
\item Aims to preserve distances
\end{itemize}
\onslide<4>
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.7]{images/animated/pipeline3.png}
\end{figure}
\vspace{-0.6cm}\begin{itemize}
\item Intuitive generation of points on flat surface
\end{itemize}
\onslide<5>
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.7]{images/animated/pipeline4.png}
\end{figure}
\vspace{-0.6cm}\begin{itemize}
\item Obtain actual points and normals from surface
\end{itemize}
\onslide<6>
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.7]{images/animated/pipeline5.png}
\end{figure}
\vspace{-0.6cm}\begin{itemize}
\item Generating the code for the robot
\end{itemize}
\end{overprint}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\fi

\subsection{Subdividing}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Subdividing the Model}
  %%
  \vspace{-0.3cm}
\begin{overprint}
\onslide<1>
\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.45\textwidth}
		\centering
		\includegraphics[scale=0.5]{images/input.png}
		\caption{Input}
	\end{subfigure}
	\hspace{4.8cm}
\end{figure}
\onslide<2->
\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.45\textwidth}
		\centering
		\includegraphics[scale=0.5]{images/input.png}
		\caption{Input}
	\end{subfigure}
	\hspace{0.5cm}
	\begin{subfigure}[t]{0.4\textwidth}
	  \centering
		\includegraphics[scale=0.4]{images/step1.png}
		\caption{Subdivided valve}
	\end{subfigure}
	\label{fig:step2}
\end{figure}
\end{overprint}
\vspace{0.5cm}
  \begin{itemize}
  \pause
    \item Simplifies the problem
    \vspace{0.1cm}\pause
    \item Allows for individual printing of components
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Subdividing the Model}
  %%
  \vspace{-0.3cm}
   \begin{figure}[h]
    \centering
	  \includegraphics[scale=0.4]{images/triangleGraph}
  	\caption{Adjacency graph (red \& blue) of triangle mesh (black)}
  	\label{fig:dib}
  \end{figure}
  \vspace{-0.5cm}
  \begin{itemize}
  \item Calculate the connectivity resulting in adjacency graph
  \vspace{0.1cm}\pause
  \item Starting from one node check each neighbor if they belong to the same class
  \vspace{0.1cm}\pause
  \item Determined by angle between the faces
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Approximation}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Approximation of the Subsurfaces}
  %%
\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.45\textwidth}
		\centering
		\includegraphics[scale=0.4]{images/step22.png}
		\caption{Cylindric heart valve leaflet}
	\end{subfigure}
	\hspace{0.5cm}
	\begin{subfigure}[t]{0.4\textwidth}
	  \centering
		\includegraphics[scale=0.4]{images/step2.png}
		\caption{Cylindric heart valve base}
	\end{subfigure}
	\label{fig:step2}
\end{figure}
  \begin{itemize}
  \item Cylindric: share a common symmetry axis
  \vspace{0.1cm}\pause
  \item Planar: all normals roughly the same
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Point Generation}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Generating Points on the Projection Plane}
  %%
  \vspace{-0.3cm}
   \begin{figure}[h]
    \centering
	  \includegraphics[scale=0.4]{images/pointGenerationLeaf}
  	\caption{Generated points for leaflet}
  	\label{fig:dib}
  \end{figure}
  \vspace{-0.7cm}
  \begin{itemize}
  \item Straight forward definition of paths
  \vspace{0.1cm}\pause
  \item Distortions taken into account by projection
  \vspace{0.1cm}\pause
  \item Use outline of projected surface to rule out points
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Raytracing}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Raytracing}
  %%
\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.4\textwidth}
		\centering
		\includegraphics[scale=0.4]{images/raytracing.png}
		\caption{Cylindric heart valve leaf}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.4\textwidth}
	  \centering
		\includegraphics[scale=0.4]{images/raytracing_flat.png}
		\caption{Flat plate}
	\end{subfigure}
	\label{fig:step4}
\end{figure}
\vspace{-0.2cm}
  \begin{itemize}
  \item Generated points in 2D correspond to rays in 3D
  \vspace{0.1cm}\pause
  \item Obtain points on the surface and their normals
  \vspace{0.1cm}\pause
  \item Requires intersecting ray with triangles of the model 
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Code Generation}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Generating Val3 Code}
  %%
  \vspace{-0.5cm}
   \begin{figure}[h]
    \centering
	  \includegraphics[scale=0.4]{images/step4}
  	\caption{Generated points and normals from model}
  	\label{fig:dib}
  \end{figure}
  \vspace{-0.5cm}
  \begin{itemize}
  \item Move point to print tip \& rotate to align normal with z-axis
   \vspace{0.1cm}\pause
  \item Add custom code before and after target is reached
   \vspace{0.1cm}\pause
  \item Possibly multiple runs depending on desired thickness
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}
  \frametitle{Overview}
  %%
\vspace{-1cm}\begin{figure}[H]
		\centering
		\includegraphics[scale=0.75]{images/animated/pipeline5.png}
\end{figure}
  %%
  %%
\end{frame}

\section{Validation}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Path Generation}
  %%
\begin{overprint}
\onslide<1>\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.4\textwidth}
		\centering
		\includegraphics[scale=0.55]{images/cubeCylinder/valveFull.png}
		\caption{Cube with cylindric top}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.4\textwidth}
	  \centering
		\includegraphics[scale=0.8]{images/cylinder/valveFull.png}
		\caption{Cylinder}
	\end{subfigure}
	\label{fig:step4}
\end{figure}
\onslide<2>\begin{figure}[H]
\captionsetup[subfigure]{}
	\begin{subfigure}[t]{0.4\textwidth}
		\centering
		\includegraphics[scale=0.25]{images/cubeCylinder/ValvePointsFull.png}
		\caption{Cube with cylindric top}
	\end{subfigure}
	\hspace{0.3cm}
	\begin{subfigure}[t]{0.4\textwidth}
	  \centering
		\includegraphics[scale=0.35]{images/cylinder/ValvePointsFull.png}
		\caption{Cylinder}
	\end{subfigure}
	\label{fig:step4}
\end{figure}
\end{overprint}
  \begin{itemize}
  \item Different models and surface combination tested
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Robot movement}
  %%
  \centering
  \href{videos/cylinderCut.mp4}{Robot cylinder print}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Conclusion}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{Conclusion}
  %%
  \begin{itemize}
  \item Handles variety of models and surfaces
  \vspace{0.1cm}\pause
  \item Automated code generation for robot
  \vspace{0.1cm}\pause
  \item Adjustable printing procedure
  \vspace{0.1cm}\pause
  \item Simple to extend, e.g. to add new paths
  \end{itemize}
  %%
  %%
\end{frame}
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\begin{frame}[allowframebreaks]
        \frametitle{Image references}
        \bibliographystyle{abbrv}
        \setbeamertemplate{bibliography item}{\insertbiblabel}
        \tiny\bibliography{references}
\end{frame}



\end{document}
%%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

